module SKUI

  require File.join( PATH, 'control.rb' )
  require File.join( PATH, 'control_manager.rb' )

  # Container control grouping child controls.
  #
  # @since 1.0.0
  class Container < Control

      include ControlManager
      
    prop( :cursor, &TypeCheck::SYMBOL )  
      
    define_event( :hover )
    define_event( :onSetCursor )
      
    def initialize()
      super()
      @properties[ :on_hover ] = false
    end  
      
    def onSetCursor(cursor)
      UI.set_cursor cursor
    end

    def zone
      px = self.position[0]
      py = self.position[1]
      pts=[Geom::Point3d.new(px,py,0),
      Geom::Point3d.new(px+@properties[ :width ],py,0),
      Geom::Point3d.new(px+@properties[ :width ],py+@properties[ :height ],0),
      Geom::Point3d.new(px,py+@properties[ :height ],0)]
      return pts
    end
    def draw(view) 
        color_fill = "ghostwhite"
        color_text = "dimgray"
        if @properties[ :on_hover ]
          color_fill = "tomato"
          color_text = "white"
        else
          color_fill = "ghostwhite"
          color_text = "dimgray"
        end
        if @properties[:background_color]
          color_fill = @properties[:background_color]
        end
        if !@properties[:enabled]
          color_fill = $color_fill_disabled
          color_text = $color_text_disabled
        end
        @bouder = Rectangle.new
        @bouder.stroke = 0
        @bouder.fill = true
        @bouder.color_fill = color_fill
        @bouder.height = @properties[ :height ]
        @bouder.width = @properties[ :width ]
        @bouder.position = self.position
        @bouder.draw(view) 
        
      end
    
  end # class
end # module